var io = require('socket.io').listen(8080);
var redis = require("redis");
var http = require('http');

function start() {
    console.log("Server has started.");

    var subscriber = redis.createClient();
    var recorderChannel = 'recording:status';
    var scheduleChannel = 'schedule:update';
    var scheduleDeleteChannel = 'schedule:delete';
    var recordCutChannel = 'record:cut';
    var mosaicUpdateChannel = 'mosaic:update';

    var sockets = [];
    var serverHost = '';

    io.set('log level', 1);
    io.set('flash policy port', 8080);
    io.set('transports', ['websocket', 'flashsocket', 'htmlfile', 'xhr-polling', 'jsonp-polling']);

    subscriber.on('message', function (channel, json) {
        console.log("Client channel recieve from channel : %s, the message : %s", channel, json);

        if (channel == recorderChannel) {
            io.sockets.emit(recorderChannel, json);
        }
        if (channel == scheduleChannel) {
            io.sockets.emit(scheduleChannel, json);
        }
        if (channel == scheduleDeleteChannel) {
            io.sockets.emit(scheduleDeleteChannel, json);
        }
        if (channel == recordCutChannel) {
            io.sockets.emit(recordCutChannel, json);
        }
        if (channel == mosaicUpdateChannel) {
            io.sockets.emit(mosaicUpdateChannel, json);
        }
    });

    subscriber.subscribe(recorderChannel);
    subscriber.subscribe(scheduleChannel);
    subscriber.subscribe(scheduleDeleteChannel);
    subscriber.subscribe(recordCutChannel);
    subscriber.subscribe(mosaicUpdateChannel);
}

exports.start = start;