<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 25.03.2016
 * Time: 11:03
 */

namespace FS\ApiBundle\Controller\v1;

use FS\UserBundle\Entity\User;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

/**
 * Class AuthController
 * @package FS\ApiBundle\Controller\v1
 * @author <vladislav@fora-soft.com>
 */
class AuthController extends Controller
{

    /**
     * @Route(path="login", methods={"POST"})
     * @param Request $request
     * @return JsonResponse
     */
    public function loginAction(Request $request)
    {
        $username = $request->request->get("username");
        $password = $request->request->get("password");

        $userManager = $this->get('fos_user.user_manager');
        $factory = $this->get('security.encoder_factory');
        $em = $this->getDoctrine()->getManager();

        /** @var User $user */
        $user = $userManager->findUserByUsername($username);
        // find user
        if ($user || is_object($user)) {
            if ($user->getType() == User::TYPE_LDAP) {
                $conn = @ldap_connect($this->container->getParameter('ldap_server'), '389');

                @ldap_set_option($conn, LDAP_OPT_PROTOCOL_VERSION, 3);
                $ldapbind = @ldap_bind($conn, $user->getLdapDN(), $password);
                @ldap_close($conn);

                $bool = $ldapbind;
            } else {
                $encoder = $factory->getEncoder($user);
                // first check
                $bool = $encoder->isPasswordValid($user->getPassword(), $password, $user->getSalt());
            }

            if ($bool) {
                if ($user->getApiToken() == null) {
                    $now = new \DateTime();

                    $user->setApiToken(
                        User::generateApiToken(
                            (string)$now->getTimestamp()
                        )
                    );

                    $em->persist($user);
                    $em->flush();
                }
                return new JsonResponse(
                    [
                        'data' => [
                            'access_token' => $user->getApiToken()
                        ]
                    ]
                );
            }
        }

        return new JsonResponse(['data' => 'User not found'], 401);
    }
}