<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 25.03.2016
 * Time: 16:37
 * Autor: <vladislav@fora-soft.com>
 */

namespace FS\ApiBundle\Controller\v1;

use FS\UserBundle\Entity\User;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;


/**
 * @Route(path="/templates")
 *
 * Class TemplateController
 * @package FS\ApiBundle\Controller\v1
 * @author <vladislav@fora-soft.com>
 */
class TemplateController extends Controller
{
    /**
     * @Route(path="")
     * @param Request $request
     * @return JsonResponse
     */
    public function indexAction(Request $request)
    {
        /** @var User $user */
        $user = $this->getUser();

        $infoTemplate = [];
        $markerTemplate = [];

        if(null !== $userGroup = $user->getUserGroup()){
            $infoTemplate = $userGroup->getTemplateInfo();
            $markerTemplate = $userGroup->getTemplateMarker();
        }

        return new JsonResponse(
            [
                'data' => [
                    'infoTemplate' => $infoTemplate,
                    'markerTemplate' => $markerTemplate
                ]
            ]
        );
    }

    /**
     * @Route(path="/info")
     * @param Request $request
     * @return JsonResponse
     */
    public function infoTemplateAction(Request $request)
    {
        /** @var User $user */
        $user = $this->getUser();

        $infoTemplate = [];

        if(null !== $userGroup = $user->getUserGroup()){
            $infoTemplate = $userGroup->getTemplateInfo();
        }

        return new JsonResponse(
            [
                'data' => $infoTemplate,
            ]
        );
    }

    /**
     * @Route(path="/marker")
     * @param Request $request
     * @return JsonResponse
     */
    public function markerTemplateAction(Request $request)
    {
        /** @var User $user */
        $user = $this->getUser();

        $markerTemplate = [];

        if(null !== $userGroup = $user->getUserGroup()){
            $markerTemplate = $userGroup->getTemplateMarker();
        }

        return new JsonResponse(
            [
                'data' =>  $markerTemplate,
            ]
        );
    }
}