<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 25.03.2016
 * Time: 12:24
 * Autor: <vladislav@fora-soft.com>
 */

namespace FS\ApiBundle\UserApiTokenizer;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * Class FSApiTokenTrait
 * @package FS\ApiBundle\UserApiTokenizer
 * @author <vladislav@fora-soft.com>
 */
trait FSApiTokenTrait
{

    /**
     * @var string
     * @ORM\Column(type="string", nullable=true)
     */
    private $apiToken;

    /**
     * @return mixed
     */
    public function getApiToken()
    {
        return $this->apiToken;
    }

    /**
     * @param mixed $apiToken
     */
    public function setApiToken($apiToken)
    {
        $this->apiToken = $apiToken;
    }

    /**
     * @param string $salt
     */
    public static function generateApiToken($salt = '')
    {
        $bigKey = FSApiTokenInterface::SEED.$salt.FSApiTokenTrait::generateSalt();

        return md5($bigKey);
    }

    /**
     * @return mixed
     */
    public static function generateSalt()
    {
        return bin2hex(openssl_random_pseudo_bytes(8));
    }
}