<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 26.02.2016
 * Time: 12:00
 */

namespace FS\BasicBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * Migration
 *
 * @ORM\Table(name="migration")
 * @ORM\Entity(repositoryClass="FS\BasicBundle\Repository\MigrationRepository")
 */
class Migration
{
    const MIGRATION__MULTI_CAMERAS = "multi_cameras";
    const MIGRATION__CONTAINERS = "containers";
    const MIGRATION__ADMIN_GROUP_RIGHTS = "admin_group_rights";
    const MIGRATION__ADMIN_GROUP_SEARCH = "admin_group_search";
    const MIGRATION__THUMBNAILS_VIEW_ADD_IMAGE = "thumbnails_add_image";
    const MIGRATION__SET_IO_USER = 'set_io_user';
    const MIGRATION__ADMIN_UPDATE_RIGHT = 'admin_update_right';

    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(type="string")
     */
    private $migrationName;

    /**
     * @var \DateTime
     *
     * @ORM\Column(type="datetime")
     */
    private $migrationDate;


    public function __construct()
    {
        $this->migrationDate = new \DateTime();
    }

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param $migrationName
     * @return $this
     */
    public function setMigrationName($migrationName)
    {
        $this->migrationName = $migrationName;

        return $this;
    }

    /**
     * @return string
     */
    public function getMigrationName()
    {
        return $this->migrationName;
    }

    /**
     * @return \DateTime
     */
    public function getMigrationDate()
    {
        return $this->migrationDate;
    }

    /**
     * @param \DateTime $migrationDate
     * @return $this
     */
    public function setMigrationDate($migrationDate)
    {
        $this->migrationDate = $migrationDate;

        return $this;
    }

    public static function getMigrationsList()
    {
        return [
            self::MIGRATION__MULTI_CAMERAS,
            self::MIGRATION__CONTAINERS,
            self::MIGRATION__ADMIN_GROUP_RIGHTS,
            self::MIGRATION__ADMIN_GROUP_SEARCH,
            self::MIGRATION__THUMBNAILS_VIEW_ADD_IMAGE,
            self::MIGRATION__SET_IO_USER
        ];
    }





}