<?php

namespace FS\BasicBundle\Form\Transformer;

use Symfony\Component\Form\DataTransformerInterface;

class DurationToIntTransformer implements DataTransformerInterface
{
    /**
     * Transforms a string (duration) to an array.
     *
     * @param  string $duration
     * @return array
     */
    public function transform($duration)
    {
        if (null === $duration) {
            return array(
                'hours' => 0,
                'minutes' => 0,
            );
        }

        $minutes = $duration / 60;

        return array(
            'hours' => floor($minutes / 60),
            'minutes' => $minutes % 60
        );
    }

    /**
     * Transforms an array (duration) to a string.
     *
     * @param  array  $duration
     * @return string
     */
    public function reverseTransform($duration)
    {

        $result = $duration['hours'] * 3600 + $duration['minutes'] * 60;

        return $result ? $result : null;
    }
}
