<?php

namespace FS\BasicBundle\Form\Type;

use FS\BasicBundle\Form\Transformer\ArrayToDateTimeTransformer;
use FS\BasicBundle\Form\Transformer\FSDateTimeToLocalizedStringTransformer;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class DateTimeType extends AbstractType
{
    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $dateOptions = $builder->get('date')->getOptions();

        $dateOptions['view_timezone'] = 'UTC';
        $dateOptions['model_timezone'] = 'UTC';
        $builder->remove('date')
            ->add(
                'date',
                'genemu_jquerydate',
                array_merge(
                    $dateOptions,
                    [
                        'widget' => 'single_text',
                        'format' => 'MM/dd/yyyy',
                        'attr' => ['readonly' => true],
                    ]
                )
            );
        /*$builder->get('date')
            ->resetViewTransformers()
            ->addViewTransformer(new FSDateTimeToLocalizedStringTransformer(
                "UTC",
                "UTC",
                \Symfony\Component\Form\Extension\Core\Type\DateType::DEFAULT_FORMAT,
                \IntlDateFormatter::NONE,
                \IntlDateFormatter::GREGORIAN,
                $dateOptions['format']
            ));*/



//        $transformer = new ArrayToDateTimeTransformer();
//        $builder->addModelTransformer($transformer);

    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {

        $minutes = [];
        for ($i = 0; $i <= 59; $i = $i + 5) {
            $minutes[$i] = $i;
        }

//        $hours = [];
//        for ($i = 0; $i <= 23; $i++) {
//            if ($i < 12) {
//                $hours[$i] = $i . ' AM';
//            } elseif ($i == 12) {
//                $hours[$i] = '12 PM';
//            } else {
//                $hours[$i] = $i - 12 . ' PM';
//            }
//        }

        $resolver->setDefaults(
            array(
                'time_widget' => 'choice',
                'date_widget' => 'single_text',
                'minutes' => $minutes,
//                'hours' => $hours,
            )
        );
    }

    public function getParent()
    {
        return 'datetime';
    }

    /**
     * @return string
     */
    public function getName()
    {
        return 'fs_datetime';
    }
}
