var listsState = 'Expand';

var $groups = $('.list-expandable'), $admin_block = $('.admin-block');
$(".list-expand-object").addClass('hidden');

var setListsState = function () {
    var expanded = $('.fa-minus').length;
    var collapsed = $('.fa-plus').length;
    listsState = expanded >= collapsed ? 'Collapse' : 'Expand';
    $('.list-appearance').html(listsState);
};

var expandGroup = function (groupIcon) {
    var $groupUsers = $('.list-expand-object', groupIcon.parent());
    if (groupIcon.hasClass('fa-plus')) groupIcon.removeClass('fa-plus').addClass('fa-minus');
    $groupUsers.removeClass('hidden');
};

var collapseGroup = function (groupIcon) {
    var $groupUsers = $('.list-expand-object', groupIcon.parent());
    if (groupIcon.hasClass('fa-minus')) groupIcon.removeClass('fa-minus').addClass('fa-plus');
    $groupUsers.addClass('hidden');
};

var toggleUsers = function (groupIcon) {
    if (groupIcon.hasClass('fa-plus')) expandGroup(groupIcon);
    else collapseGroup(groupIcon);
    setListsState();
};

var switchListsState = function (force) {
    var icons = $('.live-icon');
    var prefState = force || listsState;
    icons.each(function() {
        window[prefState.toLowerCase() + 'Group']($(this));
    });
    setListsState();
};

var checkForGroupsResults = function (searchVal) {
    var isResultsFound = false;
    var messageWarning = $('.admin-block .message-warning');
    $('.list-expandable').each(function() {
        var isAtLeastOneUser = false;
        var isGroupNotSuit = $(this).find('.list-expandable-name').html().toLowerCase().indexOf(searchVal) === -1
            && searchVal !== '';
        $(this).find('.list-expand-object > li').each(function() {
            if (!$(this).hasClass('hidden')) isAtLeastOneUser = true;
        });
        if (!isAtLeastOneUser && isGroupNotSuit) $(this).addClass('hidden');
        else {
            $(this).removeClass('hidden');
            isResultsFound = true;
        }
    });
    if (!isResultsFound) messageWarning.html('No result found!');
    else messageWarning.html('');
};

$admin_block.on('input', '.search-live', function() {
    var value = $(this).val().toLowerCase();

    if (value === '') switchListsState('Collapse');
    else switchListsState('Expand');

    $('.list-expand-object-name').each(function() {
        if ($(this).html().toLowerCase().indexOf(value) === -1 && (!$(this).nextAll('.list-expand-object-extra').length
            ||  $(this).nextAll('.list-expand-object-extra').html().toLowerCase().indexOf(value) === -1)) {
            $(this).closest('li').addClass('hidden');
        } else {
            $(this).closest('li').removeClass('hidden');
        }
    });

    checkForGroupsResults(value);
});

$groups.on('click', '.live-icon', function () {
    toggleUsers($(this));
});

$admin_block.on('click', '.list-appearance', function() {
    switchListsState();
});