<?php

namespace FS\BasicBundle\Utils;

use Symfony\Component\PropertyAccess\PropertyAccess;
use Doctrine\Common\Collections\Collection;

class ArrayCollectionFilter
{

    /**
     * @var \Doctrine\Common\Collections\Collection
     */
    protected $collection;

    /**
     * @var \Symfony\Component\PropertyAccess\PropertyAccessor
     */
    protected $accessor;

    public function __construct(Collection $collection)
    {
        $this->collection = $collection;
        $this->accessor = PropertyAccess::createPropertyAccessor();
    }

    public function findOneByProperty($propertyName, $value)
    {
        $filtered = $this->collection->filter(
          function ($entry) use ($propertyName, $value) {
              return $this->accessor->getValue($entry, $propertyName) == $value;
          }
        );

        return !$filtered->isEmpty() ? $filtered->first() : null;
    }
} 