<?php

namespace FS\CamBundle\Command;

use FS\CamBundle\Entity\Wowza;
use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Config\Definition\Exception\Exception;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use FS\CamBundle\Entity\Recording;


class CheckWowzaRecordsCommand extends ContainerAwareCommand
{
    const SLEEP_TIME = 30;
    protected function configure()
    {
        $this
            ->setName('recorder:unrecord:stop')
            ->setDescription('Run Check');
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        ////////////------------
        ////////////////Methods for checking Wowza
        //date_default_timezone_set ("UTC");
        $em = $this->getContainer()->get('doctrine')->getManager();

        $wowzas = $em->getRepository("FSCamBundle:Wowza")->findAll();
        $recordIds = [];
        //sleep(self::SLEEP_TIME);
        foreach ($wowzas as $wowza) {
            $buzz = $this->getContainer()->get('buzz');
            try {
                $responseRaw = $buzz
                    ->post(
                        'http://' . $wowza->getAddress() . ':8086/dustinSystemData',
                        ['Content-Type' => 'application/json'],
                        json_encode([
                            'command' => 'getActiveRecordId'
                        ])
                    )
                    ->getContent();
                $responseRaw = json_decode($responseRaw);
                if ($responseRaw != null) {
                    $recordIds = array_merge($recordIds, $responseRaw->currentRecordId);
                }
            } catch (\Exception $e){
                /*NOP*/
            }
            $recordings = $em->getRepository('FSCamBundle:Recording')->findAll();
            foreach ($recordings as $recording) {
                if (!in_array($recording->getRecord()->getId(), $recordIds)) {
                    if ($this->in_obj_array($wowza, $recording->getRoom()->getWowzas())) {
                        $output->writeln('<info>stop</info>');
                        $schedule = $recording->getSchedule();
                        if ($schedule) {
                            $schedule->setStatus(\FS\CamBundle\Entity\Schedule::STATUS_PENDING);
                        }
                        $this->getContainer()->get('fs_cam.recorder')->stopRecording($recording->getRecord());
                        $recording->getRecord()->setIsCompleted();
                        $record = $recording->getRecord();
                        $em->remove($recording);
                        $em->persist($record);
                        $em->flush();
                    }
                }
            }
        }

        $output->writeln('<info>Done!</info>');
    }

    private function in_obj_array($object, array $array)
    {
        foreach ($array as $aObj) {
            if ($object->getId() == $aObj->getId()) {
                return true;
            }
        }
        return false;
    }
}
