<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 23.03.2016
 * Time: 16:38
 */

namespace FS\CamBundle\Command;


use FS\UserBundle\Entity\LdapSynchronize;
use Symfony\Bundle\FrameworkBundle\Command\ContainerAwareCommand;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class LdapSyncCommand extends ContainerAwareCommand
{
    protected function configure()
    {
        $this
            ->setName('ldap:sync')
            ->setDescription('Sync Ldap Users');
    }

    /**
     * @param InputInterface $input
     * @param OutputInterface $output
     * @return int|null|void
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $ldapSynchronizer = $this->getContainer()->get('fs_user.util.ldap_synchronizer');

        $now = new \DateTime('now');

        /** @var \Doctrine\ORM\EntityManager $em */
        $em = $this->getContainer()->get('doctrine')->getManager();

        $syncLdaps = $em->getRepository('FSUserBundle:LdapSynchronize')->getLdapForSync();

        ///////////// schedule check
        /** @var LdapSynchronize $sync */
        foreach ($syncLdaps as $sync) {
            try {
                if($sync->getSyncInterval() == LdapSynchronize::LDAP_SYNCHRONIZE__SYNC_INTERVAL_WEEKLY){
                    if($now->format('w') != $sync->getDateCreate()->format('w')){
                        continue;
                    }
                }
                $ldapSynchronizer->synchronize($sync);
                if ($sync->getSyncInterval() == LdapSynchronize::LDAP_SYNCHRONIZE__SYNC_INTERVAL_NONE) {
                    $sync->setStatus(LdapSynchronize::LDAP_SYNCHRONIZE__STATUS_SYNCHRONIZED);
                } else {
                    $sync->setStatus(LdapSynchronize::LDAP_SYNCHRONIZE__STATUS_RECURRENCE_SYNCHRONIZATION);
                }
                $em->persist($sync);
                $em->flush();

            } catch (\Exception $e) {
                /* NOP */
            }

        }
    }
}