<?php

namespace FS\CamBundle\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Security;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Component\HttpFoundation\Request;
use FS\CamBundle\Entity\Record;

/**
 * Class AlertController
 * @Route("/record")
 * @Security(expression="user.hasRight('alert') || is_granted('ROLE_ADMIN')")
 */
class AlertController extends Controller
{

    /**
     * @Route("/alerts", name="alert")
     * @Template()
     */
    public function indexAction(Request $request)
    {
        $q = $this->getDoctrine()->getManager()
            ->getRepository('FSCamBundle:Alert')
            ->createQueryBuilder('a')
            ->orderBy('a.createdAt', 'DESC')
        ->getQuery()->getResult();

        $q = $this->get('fs_user.container_manager')->filterArray($q);
        $paginator = $this->get('knp_paginator')->paginate($q, $request->query->get('page', 1), 25);

        return array(
            'paginator' => $paginator,
        );
    }

    /**
     * @Route("/alerts/read_all", name="alerts_mark_as_read")
     */
    public function markAsReadAction(Request $request)
    {
        $q = $this->getDoctrine()->getManager()
            ->createQueryBuilder()
            ->update('FSCamBundle:Alert a')
            ->set('a.viewed', 1)
            ->getQuery();
        $q->execute();

        return $this->redirect($this->generateUrl("alert"));
    }
}
