<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 30.04.2015
 * Time: 16:06
 */

namespace FS\CamBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * Record
 *
 * @ORM\Table(name="filter_information")
 * @ORM\Entity
 */
class FilterTemplate
{
    const FILTER_TEMPLATE_TYPE_REGULAR = 'regular';
    const FILTER_TEMPLATE_TYPE_INFORMATION = 'information';
    const FILTER_TEMPLATE_TYPE_RECORD = 'record';
    const FILTER_TEMPLATE_TYPE_MARKER = 'marker';
    const FILTER_TEMPLATE_TYPE_EVENT = 'event';

    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var integer
     *
     * @ORM\Column(type="string", nullable=true)
     */
    private $fieldId;

    /**
     * @var boolean
     *
     * @ORM\Column(type="boolean")
     */
    private $enabled;

    /**
     * @var string
     * @ORM\Column(type="string", nullable=true)
     */
    private $filterText;

    /**
     * @var string
     * @ORM\Column(type="string")
     */
    private $filterType;

    /**
     * @ORM\ManyToOne(targetEntity="FS\CamBundle\Entity\Filter", inversedBy="filterInfoData")
     * @ORM\JoinColumn(name="filter_id", referencedColumnName="id")
     *
     **/
    private $filter;

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set fieldId
     *
     * @param integer $fieldId
     * @return FilterTemplate
     */
    public function setFieldId($fieldId)
    {

        $this->fieldId = $fieldId;

        return $this;
    }

    /**
     * Get fieldId
     *
     * @return integer
     */
    public function getFieldId()
    {
        if($this->fieldId === '0'){
            return $this->getFilterType();
        }
        return $this->fieldId;
    }

    /**
     * Set enabled
     *
     * @param boolean $enabled
     * @return FilterTemplate
     */
    public function setEnabled($enabled)
    {
        $this->enabled = $enabled;

        return $this;
    }

    /**
     * Get enabled
     *
     * @return boolean
     */
    public function getEnabled()
    {
        return $this->enabled;
    }

    /**
     * Set filterText
     *
     * @param string $filterText
     * @return FilterTemplate
     */
    public function setFilterText($filterText)
    {
        $this->filterText = $filterText;

        return $this;
    }

    /**
     * Get filterText
     *
     * @return string
     */
    public function getFilterText()
    {
        return $this->filterText;
    }

    /**
     * Set filter
     *
     * @param \FS\CamBundle\Entity\Filter $filter
     * @return FilterTemplate
     */
    public function setFilter(\FS\CamBundle\Entity\Filter $filter = null)
    {
        //$filter->addFilterInfoData($this);
        $this->filter = $filter;

        return $this;
    }

    /**
     * Get filter
     *
     * @return \FS\CamBundle\Entity\Filter
     */
    public function getFilter()
    {
        return $this->filter;
    }

    public function setFilterType($filterType)
    {
        $this->filterType = $filterType;

        return $this;
    }

    public function getFilterType()
    {
        return $this->filterType;
    }
}
