<?php

namespace FS\CamBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Preset
 *
 * @ORM\Table(name="presets")
 * @ORM\Entity
 */
class Preset
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=128)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="data", type="text")
     */
    private $data;

    /**
     * var Camera
     * @ORM\ManyToOne(targetEntity="Camera", inversedBy="presets")
     * @ORM\JoinColumn(name="camera_id", referencedColumnName="id")
     **/
    private $camera;

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param  string $name
     * @return Preset
     */
    public function setName($name)
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get name
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set data
     *
     * @param  string $data
     * @return Preset
     */
    public function setData($data)
    {
        $this->data = $data;

        return $this;
    }

    /**
     * Get data
     *
     * @return string
     */
    public function getData()
    {
        return $this->data;
    }

    /**
     * Set camera
     *
     * @param  \FS\CamBundle\Entity\Camera $camera
     * @return Preset
     */
    public function setCamera(\FS\CamBundle\Entity\Camera $camera = null)
    {
        $this->camera = $camera;

        return $this;
    }

    /**
     * Get camera
     *
     * @return \FS\CamBundle\Entity\Camera
     */
    public function getCamera()
    {
        return $this->camera;
    }
}
