<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 01.02.2016
 * Time: 12:58
 */

namespace FS\CamBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Table(name="restrict_access_week_day")
 * @ORM\Entity(repositoryClass="FS\CamBundle\Repository\RestrictAccessWeekDayRepository")
 */
class RestrictAccessWeekDay
{
    /**
     * @var integer
     *
     * @ORM\Column(type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var integer
     *
     * @ORM\Column(type="integer")
     */
    private $weekDay;

    /**
     * @var boolean
     *
     * @ORM\Column(type="boolean", options={"default":false})
     */
    private $isEnable = false;

    /**
     * @var array
     *
     * @ORM\Column(type="simple_array", nullable=true)
     */
    private $startTime;

    /**
     * @var array
     *
     * @ORM\Column(type="simple_array", nullable=true)
     */
    private $endTime;

    /**
     * @var RestrictAccess
     *
     * @ORM\ManyToOne(targetEntity="FS\CamBundle\Entity\RestrictAccess", inversedBy="weekDays", cascade={"persist"})
     * @ORM\JoinColumn(name="r_access_id", referencedColumnName="id")
     *
     */
    private $restrictAccess;

    public function __construct()
    {
        $this->isEnable = false;
    }

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @return int
     */
    public function getWeekDay()
    {
        return $this->weekDay;
    }

    /**
     * @param int $weekDay
     * @return RestrictAccessWeekDay
     */
    public function setWeekDay($weekDay)
    {
        $this->weekDay = $weekDay;
        return $this;
    }

    /**
     * @return boolean
     */
    public function isIsEnable()
    {
        return $this->isEnable;
    }

    /**
     * @param boolean $isEnable
     * @return RestrictAccessWeekDay
     */
    public function setIsEnable($isEnable)
    {
        $this->isEnable = $isEnable;
        return $this;
    }

    /**
     * @return array
     */
    public function getStartTime()
    {
        return $this->startTime;
    }

    /**
     * @param array $startTime
     * @return RestrictAccessWeekDay
     */
    public function setStartTime($startTime)
    {
        $this->startTime = $startTime;
        return $this;
    }

    /**
     * @return array
     */
    public function getEndTime()
    {
        return $this->endTime;
    }

    /**
     * @param array $endTime
     * @return RestrictAccessWeekDay
     */
    public function setEndTime($endTime)
    {
        $this->endTime = $endTime;
        return $this;
    }

    /**
     * @return RestrictAccess
     */
    public function getRestrictAccess()
    {
        return $this->restrictAccess;
    }

    /**
     * @param RestrictAccess $restrictAccess
     * @return $this
     */
    public function setRestrictAccess($restrictAccess)
    {
        $this->restrictAccess = $restrictAccess;

        return $this;
    }

    public function getWeekDayName()
    {
        switch ($this->weekDay) {
            case 1:
                return 'Mon';
            case 2:
                return 'Tue';
            case 3:
                return 'Wed';
            case 4:
                return 'Thur';
            case 5:
                return 'Fri';
            case 6:
                return 'Sat';
            case 7:
                return 'Sun';
            default:
                return 'error';
        }
    }

}