<?php

namespace FS\CamBundle\EventListener;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Event\OnFlushEventArgs;
use FS\CamBundle\Entity\Template;
use FS\CamBundle\Entity\TemplateField;


class TemplateVersionListener
{

    public function onFlush(OnFlushEventArgs $args)
    {

        $em = $args->getEntityManager();
        $uow = $em->getUnitOfWork();
        $eventManager = $em->getEventManager();

        $changedTemplates = new ArrayCollection();
        foreach ($uow->getScheduledEntityUpdates() AS $entity) {
            if ($entity instanceof TemplateField && !$changedTemplates->contains($entity->getTemplate())) {
                $template = $entity->getTemplate();
                //$template->setVersion($template->getVersion() + 1);
                $uow->persist($template);


                $classMetadata = $em->getClassMetadata((get_class($entity)));
                $uow->computeChangeSet($classMetadata, $entity);

                $classMetadata = $em->getClassMetadata(get_class($template));
                $uow->recomputeSingleEntityChangeSet($classMetadata, $template); // We need to manually tell EM to notice the changes

                $changedTemplates[] = $template;
               // print $template->getVersion();
            }
        }
        $eventManager ->addEventListener('onFlush', $this);

    }
}