<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 04.02.2016
 * Time: 17:04
 */

namespace FS\CamBundle\Expiration;


use FS\CamBundle\Entity\Expiration;

trait ExpirationTrait
{
    /**
     * @var Expiration
     *
     * @ORM\OneToOne(targetEntity="FS\CamBundle\Entity\Expiration",cascade={"persist"})
     * @ORM\JoinColumn(name="expiration_from_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $expiration;

    /**
     * @return Expiration
     */
    public function getExpiration(){
        return $this->expiration;
    }

    /**
     * @param $expiration
     * @return $this
     */
    public function setExpiration($expiration){
        $this->expiration = $expiration;
        return $this;
    }

    /**
     * @return bool
     */
    private function checkExpiration()
    {
        if($this->getExpiration() != null){
            if($this->expiration->getType() == Expiration::ACCESS_EXPIRATION){
                $now = new \DateTime();
                if($this->expiration->getExpirationFrom() <= $now){
                    return true;
                }
            }
        }
        return false;
    }
}