<?php

namespace FS\CamBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class ExceptionType extends AbstractType
{
    /**
     * @param FormBuilderInterface $builder
     * @param array                $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('name', null, ['label' => 'Exception name'])
            ->add(
                'date',
                'genemu_jquerydate',
                [
                    'widget' => 'single_text',
                    'format' => 'MM/dd/yyyy',
                ]
            );
    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'FS\CamBundle\Entity\Exception'
            )
        );
    }

    /**
     * @return string
     */
    public function getName()
    {
        return 'exception';
    }
}
