<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 04.02.2016
 * Time: 16:53
 */

namespace FS\CamBundle\Form\Type;


use Doctrine\Common\Persistence\ObjectManager;
use FS\CamBundle\Form\Transformer\ExpirationTransformer;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

class ExpirationType extends AbstractType
{
    /** @var ObjectManager */
    private $om;

    public function __construct(ObjectManager $om)
    {
        $this->om = $om;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add("type", "choice", [
                "choices" => ["No Expiration", "Access Expiration"],
                "expanded" => true
            ])
            ->add("expiration_from", "genemu_jquerydate", [
                'label' => 'Access Expiration',
                'widget' => 'single_text',
                'format' => 'MM/dd/yyyy',
                'attr' => ['class' => "keep-until-date"]
            ])
            ->add("id", "hidden")
            ->addModelTransformer(new ExpirationTransformer($this->om));
    }

    /**
     * Returns the name of this type.
     *
     * @return string The name of this type
     */
    public function getName()
    {
        return 'expiration';
    }
}