<?php

namespace FS\CamBundle\Form\Type;

use FS\CamBundle\Entity\Template;
use FS\CamBundle\Template\TemplateTypes;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class HelpTopicType extends AbstractType
{
    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('title')
            ->add('content', null, array(
                'attr' => array('rows' => '10'),
            ));
    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'FS\CamBundle\Entity\HelpTopic',
                'cascade_validation' => true,
                'editable' => true,
            )
        );
    }

    /**
     * @return string
     */
    public function getName()
    {
        return 'help_topic';
    }
}
