<?php

namespace FS\CamBundle\Form\Type;

use FS\CamBundle\Template\TemplateTypes;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use FS\CamBundle\Form\EventListener\TemplateFieldsSubscriber;
use Symfony\Component\Security\Core\SecurityContext;

class MarkerType extends AbstractType
{


    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('name', null, ['label' => 'Event'])
            ->add(
                'templateData',
                'template_data',
                [
                    'template_aware' => $builder->getData(),
                ]
            );
    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'FS\CamBundle\Entity\Marker'
            )
        );
    }

    /**
     * @return string
     */
    public function getName()
    {
        return 'marker';
    }
}
