<?php

namespace FS\CamBundle\Form\Type;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Persistence\ObjectManager;
use FS\BasicBundle\Utils\ArrayCollectionFilter;
use FS\CamBundle\Entity\AccessedByUsersAndGroupsInterface;
use FS\CamBundle\Template\TemplateTypes;
use FS\CamBundle\Entity\TemplateField;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use FS\CamBundle\Entity\Record;

class RecordInfoType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {


        $builder
            ->add('name', null,
                [
                    'label' => 'Recording Name',
                    'pattern' => '.+[.\S]+(.)*'
                ]
            )
            ->add(
                'templateData',
                'template_data',
                [
                    'template_aware' => $builder->getData(),
                ]
            );

    }

    /**
     * {@inheritdoc}
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'FS\CamBundle\Entity\Record',
            )
        );
    }

    /**
     * {@inheritdoc}
     */
    public function getName()
    {
        return 'record_info';
    }
}
