<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 29.01.2016
 * Time: 16:22
 */

namespace FS\CamBundle\Form\Type;


use FS\CamBundle\Entity\RestrictAccess;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class RestrictAccessType extends AbstractType
{

    public function buildForm(FormBuilderInterface $builder, array $options)
    {

        $builder->add(
            'weekDays',
            'fs_list',
            [
                'type' => 'restrict_day_access',
                'label' => "Restrict Access",
                'allow_add' => false,
                'allow_delete' => false,
                'label_render' => false,
                'widget_add_btn' => false,
                'options' => [
                    'label_render' => false,
                    'widget_remove_btn' => false,
                    'horizontal' => true,
                ],
            ]
        );
    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'FS\CamBundle\Entity\RestrictAccess',
                'cascade_validation' => true,
            )
        );
    }
    /**
     * Returns the name of this type.
     *
     * @return string The name of this type
     */
    public function getName()
    {
        return 'restrict_access';
    }
}