<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 01.02.2016
 * Time: 10:55
 */

namespace FS\CamBundle\Form\Type;


use FS\CamBundle\Entity\RestrictAccessWeekDay;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\Form\FormView;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class RestrictedAccessWeekDayType extends AbstractType
{

    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder->add('startTime', 'collection', [
            'type' => 'hidden',
            'allow_add' => 'true',
            'allow_delete' => 'true',
            'by_reference' => 'false',
            'prototype' => 'true',
            'attr' => [
                'class' => 'restrict-start-fields-list hidden'
            ],
            'options' => [
                'attr' => [
                    'class' => 'hidden'
                ]
            ]
        ]);
        $builder->add('endTime', 'collection', [
            'type' => 'hidden',
            'allow_add' => 'true',
            'allow_delete' => 'true',
            'by_reference' => 'false',
            'prototype' => 'true',
            'attr' => [
                'class' => 'restrict-end-fields-list hidden'
            ],
            'options' => [
                'attr' => [
                    'class' => 'hidden'
                ]
            ]
        ]);

        $builder->addEventListener(
            FormEvents::PRE_SET_DATA, function (FormEvent $event) {
            /** @var RestrictAccessWeekDay $dayAccess */
            $dayAccess = $event->getData();

            $form = $event->getForm();
            $form->add('isEnable', 'checkbox', [
                'label' => $dayAccess->getWeekDayName(),
                'data' => !$dayAccess->isIsEnable(),
                'attr' => [
                    'class' => 'restrict-field-is-enabled',
                ]
            ]);
        });

        $builder->addEventListener(FormEvents::PRE_SUBMIT, function (FormEvent $event) {
            $data = $event->getData();
            if ($data !== null && array_key_exists('isEnable', $data)) {
                unset($data['isEnable']);
            } else {
                $data['startTime'] = null;
                $data['endTime'] = null;
                $data['isEnable'] = '1';
            }
            $event->setData($data);
        });
    }

    public function buildView(FormView $view, FormInterface $form, array $options)
    {
        /** @var RestrictAccessWeekDay $dayAccess */
        $dayAccess = $form->getData();
    }

    public function finishView(FormView $view, FormInterface $form, array $options)
    {
        /** @var RestrictAccessWeekDay $dayAccess */
        $dayAccess = $form->getData();

    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'FS\CamBundle\Entity\RestrictAccessWeekDay',
                'cascade_validation' => true,
            )
        );
    }

    /**
     * Returns the name of this type.
     *
     * @return string The name of this type
     */
    public function getName()
    {
        return 'restrict_day_access';
    }
}