<?php

namespace FS\CamBundle\Form\Type;


use FS\CamBundle\Entity\Template;
use FS\CamBundle\Form\Transformer\ArrayToTemplateDataTransformer;
use FS\CamBundle\Template\TemplateTypes;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;
use FS\CamBundle\Form\EventListener\TemplateFieldsSubscriber;
use Symfony\Component\Security\Core\SecurityContext;

class TemplateDataType extends AbstractType
{

    private $securityContext;

    public function __construct(SecurityContext $securityContext)
    {
        $this->securityContext = $securityContext;
    }

    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {

        $user = $this->securityContext->getToken()->getUser();
        $builder->addEventSubscriber(new TemplateFieldsSubscriber($user, $options['template_aware']));

    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
          array(
            'by_reference' => false,
            'label_render' => false,
            'template_aware' => null,
          )
        );
    }

    /**
     * @return string
     */
    public function getName()
    {
        return 'template_data';
    }
}
