<?php

namespace FS\CamBundle\Repository;

use Doctrine\ORM\EntityRepository;
use FS\CamBundle\Entity\MosaicQueue;

/**
 * MosaicQueueRepository
 *
 * This class was generated by the PhpStorm "Php Annotations" Plugin. Add your own custom
 * repository methods below.
 */
class MosaicQueueRepository extends EntityRepository
{
    /**
     * @return array
     */
    public function getAllWaiting()
    {
        $qb = $this->createQueryBuilder('mosaic')
            ->select('mosaic')
            ->where('mosaic.status = :status')
            ->setParameter('status', MosaicQueue::STATUS_WAITING);

        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getOldForDelete()
    {
        $date = new \DateTime();
        $date->modify('-1 week');
        $qb = $this->createQueryBuilder('mosaic')
            ->select('mosaic')
            ->where('mosaic.created < :date')
            ->orWhere('mosaic.status = :status')
            ->andWhere('mosaic.status <> :statusFail')
            ->setParameter('date', $date)
            ->setParameter('status', MosaicQueue::STATUS_FAIL)
            ->setParameter('statusFail', MosaicQueue::STATUS_FAIL_FILES_COUNT);

        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getFailed()
    {
        $qb = $this->createQueryBuilder('mosaic')
            ->select('mosaic')
            ->where('mosaic.status = :status')
            ->setParameter('status', MosaicQueue::STATUS_FAIL);

        return $qb->getQuery()->getResult();
    }
    /**
     * @param $recordId
     * @return mixed
     */
    public function getMosaicByRecordId($recordId)
    {
        $qb = $this->createQueryBuilder('mosaic')
            ->select('mosaic')
            ->where('mosaic.record = :record')
            ->setParameter('record', $recordId);

        return $qb->getQuery()->getOneOrNullResult();
    }
}
