<?php

namespace FS\CamBundle\Repository;

use Doctrine\ORM\EntityRepository;
use FS\CamBundle\Entity\Schedule;

class RecordingRepository extends EntityRepository
{
    public function getExpiredRecordings($now){
        $qb = $this->createQueryBuilder('r')
            ->select('r','s','room','record')
            ->leftJoin('r.schedule','s')
            ->leftJoin('r.room','room')
            ->leftJoin('r.record','record')
            ->where('r.stopAt <= :now')
            ->andWhere('r.schedule IS NOT NULL')
            ->setParameter('now', $now);

        return $qb->getQuery()->getResult();
    }

    public function getExpiredRecordingsToDel($now){
        $qb = $this->createQueryBuilder('r')
            ->select('r','s','room','record')
            ->leftJoin('r.schedule','s')
            ->leftJoin('r.room','room')
            ->leftJoin('r.record','record')
            ->where('r.stopAt < :now')
            ->andWhere('r.schedule IS NULL')
            ->setParameter('now', $now);

        return $qb->getQuery()->getResult();
    }
}
