<?php

namespace FS\CamBundle\Repository;

use Doctrine\ORM\EntityRepository;
use FS\CamBundle\Entity\Schedule;

class ScheduleRepository extends EntityRepository
{
    public function getQBAllOrderedById()
    {
        $qb = $this->createQueryBuilder('s')
            ->select('s', 'room', 'user', 'recur')
            ->leftJoin('s.createdBy', 'user')
            ->leftJoin('s.room', 'room')
            ->leftJoin('s.recur', 'recur')
            ->orderBy('s.id', 'DESC');
        return $qb;
    }

    public function getAllUsers()
    {
        $resultRaw = $this->getQBAllOrderedById()
            ->getQuery()
            ->getResult();

        $result = [];

        /** @var Schedule $schedule */
        foreach ($resultRaw as $schedule) {
            if ($schedule->getCreatedBy() != null) {
                $result[$schedule->getCreatedBy()->getId()] = $schedule->getCreatedBy()->getUsername();
            }

        }
        return $result;
    }

    public function getAllRooms()
    {
        $resultRaw = $this->getQBAllOrderedById()
            ->getQuery()
            ->getResult();

        $result = [];
        /** @var Schedule $schedule */
        foreach ($resultRaw as $schedule) {
            if ($schedule->getRoom() != null) {
                $result[$schedule->getRoom()->getId()] = $schedule->getRoom()->getName();
            }

        }
        return $result;
    }
}
