app.controller('CutToolsCtrl', function ($scope, $http, $filter) {
    /**
     * Tools
     */

    $scope.cutInTime = null;
    $scope.cutOutTime = null;

    $scope.cutCueIn = function () {
        if ($scope.cutInTime == null) {
            var time = getSWF().getCurrentTime();
            getSWF().addCutPoint(time);
            $scope.cutInTime = time;
        }

    };

    $scope.cutCueOut = function () {
        if ($scope.cutOutTime == null) {
            var time = getSWF().getCurrentTime();
            getSWF().addCutPoint(time);
            $scope.cutOutTime = time;
        }

    };

    $scope.cutStart = function () {
        $http.get('/api/clipRecord/' + settings.recordId + '/' + $scope.cutInTime + '/' + $scope.cutOutTime)
            .success(function (data, status) {
                $('#clip-cut-result').html(data);
            }).error(function (data, status){
                $('#clip-cut-result').html(data);
            });
        $scope.cutInTime = null;
        $scope.cutOutTime = null;
        getSWF().cutClear();
    };

    $scope.clearMarkers = function () {
        $scope.cutInTime = null;
        $scope.cutOutTime = null;
        getSWF().cutClear();
    };

    $scope.isDisabled = function () {
        return (($scope.cutInTime == null) | ($scope.cutOutTime == null))
    };
    $scope.isOnlyOne = function () {
        return (($scope.cutInTime == null) & ($scope.cutOutTime == null))
    };
});

(function ($) {
    var recordCutChannel = 'record:cut';

    var options = settings.node;
    var socket = io.connect(options.host);
    socket.on(recordCutChannel, function (json) {
        var record = $.parseJSON(json);
        var $clipResult = $('#clip-cut-result');
        if (record.record_id == +settings.recordId) {
            console.log('replace');
            $clipResult
                .html(record.msg)
        }
    });
    console.log('record Cut');
})(jQuery);