(function ($) {
    var scheduleChannel = 'mosaic:update';
    var options = settings.node;

    var socket = io.connect(options.host);

    socket.on(scheduleChannel, function (json) {
        var mosaic = $.parseJSON(json);
        var $mosaicElement = $("li.mosaic[data-record='" + mosaic.recordId + "']");
        switch (mosaic.status) {
            case 1:
                $mosaicElement
                    .find('a')
                    .removeClass("mosaic-marked")
                    .html("Multiview");
                break;
            case 3:
                if (mosaic.progress == 0) {
                    $mosaicElement
                        .find('a')
                        .addClass("mosaic-marked")
                        .html("Creating Multiview... <span class='mosaic-process'>0</span>%");
                } else {
                    $mosaicElement
                        .find('a')
                        .find('span')
                        .html(mosaic.progress);
                }
                break;
            case 4:
            case 5:
            default :
                $mosaicElement.find('a')
                    .removeClass("mosaic-marked")
                    .addClass('disabled')
                    .html("Multiview Failed");
                break;
        }
    });
    console.log('records listen init');
})(jQuery);