(function ($) {
    "use strict";

    var recorderChannel = 'recording:status';

    var methods = {
        init: function (params, doctorId, conf) {
            return this.each(function () {
                if (window.io == undefined || conf == true) {
                    return false;
                }
                var options = {host: 'http://localhost:8080'};

                var $this = $(this),
                    data = $this.data(recorderChannel),
                    socket = io.connect(options.host);

                if (!data) {
                    $(this).data(recorderChannel, {socket: socket});
                    data = $this.data(recorderChannel);
                }

                data.socket.emit('init', doctorId, conf);
                data.socket.on(recorderChannel, function (json) {
                    var obj = $.parseJSON(json);
                    console.log(obj);
                    // todo update room status here;

                });

                console.log('roomStatusUpdate Init');
            });
        }
    };

    $.fn.roomStatusUpdate = function (method) {
        if (methods[method]) {
            return methods[method].apply(this, Array.prototype.slice.call(arguments, 1));
        } else if (typeof method === 'object' || !method) {
            return methods.init.apply(this, arguments);
        } else {
            $.error('Method named ' + method + ' doesn\'t exist for $.roomStatusUpdate');
        }
    };
})(jQuery);