(function ($) {
    var scheduleChannel = 'schedule:update';
    var scheduleDeleteChannel = 'schedule:delete';
    var options = settings.node;

    var socket = io.connect(options.host);

    socket.on(scheduleChannel, function (json) {
        var schedule = $.parseJSON(json);
        console.log(schedule);
        var scheduleView = $('#schedule-item-' + schedule.id);
        console.log('#schedule-item-' + schedule.id);
        switch (schedule.status){
            case 'update':
                if (scheduleView.length > 0) {
                    console.log('replace');
                    scheduleView
                        .html(schedule.content)
                        .css('background', 'yellow')
                        .stop().animate({backgroundColor: 'white'}, 300);
                }
                break;
            case 'blocked':
                console.log('blocked');
                console.log('#schedule-item-' + schedule.id);
                $(scheduleView.children()[0]).css('color','red');
                break;
            case 'ready':
                console.log('ready');
                console.log('#schedule-item-' + schedule.id);
                $(scheduleView.children()[0]).css('color','').removeClass('schedule-conflict');
                break;
            case 'conflict':
                console.log('ready');
                console.log('#schedule-item-' + schedule.id);
                $(scheduleView.children()[0]).css('color','').addClass('schedule-conflict');
                break;
            default:
                break;
        }

    });

    socket.on(scheduleDeleteChannel, function (json) {
        var schedule = $.parseJSON(json);
        console.log(schedule);
        var scheduleView = $('#schedule-item-' + schedule.id);
        console.log('#schedule-item-' + schedule.id);
        $(scheduleView.children()[5]).html('Finished');
        $(scheduleView.children()[0]).css('color','');
        //scheduleView.remove();
    });

    console.log('schedule listen init');


})(jQuery);