<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 01.02.2016
 * Time: 15:41
 */

namespace FS\CamBundle\RestrictAccess;


use FS\CamBundle\Entity\RestrictAccess;
use FS\CamBundle\Entity\RestrictAccessWeekDay;

/**
 * Class RestrictAccessBuilder
 * @package FS\CamBundle\RestrictAccess
 */
class RestrictAccessBuilder
{
    /**
     * @return RestrictAccess
     */
    public static function buildRestrictAccess()
    {
        $restrictAccess = new RestrictAccess();

        static::addWeekDays($restrictAccess);

        return $restrictAccess;
    }

    private static function addWeekDays(RestrictAccess $restrictAccess)
    {
        $restrictAccessDay = new RestrictAccessWeekDay();
        $restrictAccessDay->setWeekDay(7);
        $restrictAccess->addWeekDay($restrictAccessDay);

        for($i = 1; $i < 7; ++$i){
            $restrictAccessDay = new RestrictAccessWeekDay();
            $restrictAccessDay->setWeekDay($i);
            $restrictAccess->addWeekDay($restrictAccessDay);
        }
    }
    public static function cloneRestrictAccess(RestrictAccess $restrictAccess){
        $copy = new RestrictAccess();
        /** @var RestrictAccessWeekDay $weekDay */
        foreach($restrictAccess->getWeekDays() as $weekDay){
            $copy->addWeekDay(clone $weekDay);
        }
        return $copy;
    }


}