<?php
/**
 * User: andrey
 */

namespace FS\CamBundle\Template;


use FS\CamBundle\Entity\Marker;
use FS\UserBundle\Entity\User;
use Symfony\Component\PropertyAccess\PropertyAccess;

class TemplateTypes
{
    const TYPE_MARKER = 'marker';
    const TYPE_INFO = 'info';

    static public function getAllowedTypes()
    {
        return [
          self::TYPE_INFO,
          self::TYPE_MARKER
        ];
    }

    static public function getTempalateType(TemplateAwareInterface $entity)
    {
        if ($entity instanceof Marker) {
            return self::TYPE_MARKER;
        } else {
            return self::TYPE_INFO;
        }
    }

    static public function getTemplate(TemplateAwareInterface $entity, User $user)
    {
        if (null === $userGroup = $user->getUserGroup()) {
            return null;
        }


        $accessor = PropertyAccess::createPropertyAccessor();
        $template = $accessor->getValue($userGroup, self::getTempalateType($entity) . 'Template');

        if (null === $template) {
            return null;
        }

        return $template;

    }
}