<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 10.03.2015
 * Time: 12:24
 */

namespace FS\CamBundle\Utils;


use Buzz\Browser;
use FS\CamBundle\Entity\Camera;
use Predis\Client as RedisClient;
use Symfony\Component\HttpFoundation\RequestStack;

class CameraIOManager
{
    private $buzz;
    private $redis;
    private $requestStack;
    private $host;

    public function __construct(Browser $buzz, RedisClient $redis, RequestStack $requestStack)
    {
        $this->buzz = $buzz;
        $this->redis = $redis;
        $this->requestStack = $requestStack;
        $this->host = $requestStack->getCurrentRequest()->getHost();
    }

    public function configureIO(Camera $camera)
    {
        if (!$camera->getIoConfigured()) {
            $rooms = $camera->getRooms();
            foreach($rooms as $room){
                $host = 'http://' . $camera->getUsername() . ':' . $camera->getPassword() . '@' . $camera->getIp() . ':' . $camera->getPort();

                $response = new \Buzz\Message\Response();
                $request = new \Buzz\Message\Request('GET', '/', $host);

                $client = $this->buzz->getClient();

                $resource = '/axis-cgi/param.cgi?action=add';
                $resource .= "&group=EventServers.HTTP&template=http_config";
                $resource .= "&EventServers.HTTP.H.Name=MgSiteHttpRoom".uniqid();
                $resource .= "&EventServers.HTTP.H.Address=http://" . $this->host . "/api/cameraIOResponse";


                $request->setResource($resource);
                $client->send($request, $response);

                $hEvent = $response->getContent();

                list($hEvent) = preg_split('[ ]', $hEvent);

                $resource = '/axis-cgi/param.cgi?action=add';
                $resource .= '&group=Event&template=event';
                $resource .= '&Event.E.Name=IOEventRoom';
                $resource .= '&Event.E.Type=T';
                $resource .= '&Event.E.HWInputs=1';

                $request->setResource($resource);
                $client->send($request, $response);

                $eNum = $response->getContent();

                list($eNum) = preg_split('[ ]', $eNum);

                $resource = '/axis-cgi/param.cgi?action=add';
                $resource .= '&group=Event.' . $eNum . '.Actions&template=httpaction';
                $resource .= '&Event.' . $eNum . '.Actions.A.Type=N';
                $resource .= '&Event.' . $eNum . '.Actions.A.Server=' . $hEvent;
                $resource .= '&Event.' . $eNum . '.Actions.A.CustomParams=roomId='. $room->getId().'%26cameraId='.$camera->getId();

                $request->setResource($resource);
                $client->send($request, $response);

                $eAum = $response->getContent();

                list($eAum) = preg_split('[ ]', $eAum);

                $camera->setCameraIoA($eAum);
                $camera->setCameraIoE($eNum);
                $camera->setCameraIoH($hEvent);
                $camera->setIoSettings(true);

                $camera->setIoConfigured(true);
            }

        }
    }
}