<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 18.08.2015
 * Time: 15:48
 */

namespace FS\MobileBundle\Utils;


use Symfony\Component\Filesystem\Filesystem;
use Symfony\Component\HttpKernel\Kernel;

class FileReceiver
{

    private $kernel;
    private $filesystem;


    public function __construct
    (
        Kernel $kernel,
        Filesystem $filesystem
    )
    {
        $this->kernel = $kernel;
        $this->filesystem = $filesystem;

    }

    public function receive($fileName, $contentLength, $append = false)
    {
        if (!file_exists($this->kernel->getRootDir() . "/../web/TMPUpload")) {
            mkdir($this->kernel->getRootDir() . "/../web/TMPUpload", 0777, true);
        }

        $mode = $append == false ? "w+" : "a+";
        $file = $this->kernel->getRootDir() . "/../web/TMPUpload/" . $fileName.'.mp4';
        $fileReader = fopen('php://input', "r");
        $fileWriter = fopen($file, $mode);
        while (true) {
            $buffer = fgets($fileReader, 4096);
            if (strlen($buffer) == 0) {
                fclose($fileReader);
                fclose($fileWriter);
                break;
            }
            fwrite($fileWriter, $buffer);
        }
        $counter = $this->filesize($fileName);
        return ((string)$counter) == ((string)$contentLength);
    }

    public function filesize($fileName)
    {
        @clearstatcache();

        $fp = $this->kernel->getRootDir() . "/../web/TMPUpload/" . $fileName.'.mp4';
        $return = @filesize($fp);
        /*if (is_resource($fp)) {
            if (PHP_INT_SIZE < 8) {
                // 32bit
                if (0 === fseek($fp, 0, SEEK_END)) {
                    $return = 0.0;
                    $step = 0x7FFFFFFF;
                    while ($step > 0) {
                        if (0 === fseek($fp, -$step, SEEK_CUR)) {
                            $return += floatval($step);
                        } else {
                            $step >>= 1;
                        }
                    }
                }
            } elseif (0 === fseek($fp, 0, SEEK_END)) {
                // 64bit
                $return = ftell($fp);
            }
        }*/
        return (string)$return;
    }
}