<?php

namespace FS\UserBundle\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Security;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\StreamedResponse;
use Symfony\Component\Process\Process;

/**
 * Class UpdateController
 * @package FS\UserBundle\Controller
 *
 * @Route("/update")
 */
class UpdateController extends Controller
{
    /**
     * @Route(path="/", name="update")
     * @Template("FSUserBundle:Update:index.html.twig")
     * @Security(expression="is_granted('ROLE_ADMIN') || user.hasRight('admin--update')")
     */
    public function indexAction()
    {
        return [];
    }

    /**
     * @Route(path="/upload", name="update_upload")
     * @Security(expression="is_granted('ROLE_ADMIN') || user.hasRight('admin--update')")
     */
    public function uploadAction(Request $request)
    {
        if ($request->isXmlHttpRequest()) {
            $directory = $this->get('kernel')->getRootDir().'/../tmp/';
            foreach ($request->files as $uploadedFile) {
                $name = $uploadedFile->getClientOriginalName();
                $file = $uploadedFile->move($directory, $name);

                return new JsonResponse([
                    'message' => 'File has been successfully uploaded'
                ], 200);
            }

            return new JsonResponse([
                'message' => 'Wow, that works!'
            ], 200);
        }
    }

    /**
     * @Route(path="/start", name="update_start")
     * @Security(expression="is_granted('ROLE_ADMIN') || user.hasRight('admin--update')")
     */
    public function startAction()
    {
        $root = $this->get('kernel')->getRootDir(); // To be sure of location
        $process = new Process('bash '.$root.'/../update.sh 2> '.$root.'/logs/update.log');

        $response = new StreamedResponse(function() use ($process) {
            $process->run(function ($type, $buffer) use (&$output) {
                if (strpos($buffer, 'num_of_files') !== false) {
                    echo 'event: num_of_files'.PHP_EOL;
                    echo 'data: '.explode('=', $buffer)[1].PHP_EOL;
                } elseif (strpos($buffer, 'update_finished') !== false) {
                    echo 'event: update_finished'.PHP_EOL;
                    echo 'data: true'.PHP_EOL;
                } else {
                    $message = 'data: ';
                    if (Process::ERR === $type) {
                        $message .= 'ERR: '.$buffer;
                    } else {
                        $message .= $buffer;
                    }
                    echo $message.PHP_EOL;
                }
                echo PHP_EOL;
                ob_flush();
                flush();
            });
        });
        $response->headers->set('Content-Type', 'text/event-stream');
        $response->headers->set('Cache-Control', 'no-cache');
        $response->send();
    }
}
