<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 21.03.2016
 * Time: 10:58
 * @email: <vladislav@fora-soft.com>
 */

namespace FS\UserBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass="FS\UserBundle\Repository\LdapServerRepository")
 * @ORM\Table(name="ldap_server")
 */
class LdapServer
{

    const LDAP_SERVER__STATUS_CONNECTED = 'connected';

    /**
     * @var integer
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @ORM\Column(type="string",length=255)
     *
     * @Assert\NotBlank
     */
    private $server;

    /**
     * @ORM\Column(type="string",length=255)
     *
     * @Assert\NotBlank
     */
    private $status;

    /**
     * @ORM\Column(type="string",length=255)
     *
     * @Assert\NotBlank
     */
    private $username;

    /**
     * @ORM\Column(type="string",length=255)
     *
     * need to encrypt.
     *
     * @Assert\NotBlank
     */
    private $password;


    /**
     * @var string
     *
     * @ORM\Column(type="string")
     */
    private $dn;

    /**
     * LdapServer constructor.
     */
    public function __construct()
    {
        $this->status = self::LDAP_SERVER__STATUS_CONNECTED;
    }

    /**
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param int $id
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getServer()
    {
        return $this->server;
    }

    /**
     * @param mixed $server
     * @return $this
     */
    public function setServer($server)
    {
        $this->server = $server;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * @param mixed $status
     * @return $this
     */
    public function setStatus($status)
    {
        $this->status = $status;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getUsername()
    {
        return $this->username;
    }

    /**
     * @param mixed $username
     * @return $this
     */
    public function setUsername($username)
    {
        $this->username = $username;
        return $this;
    }

    /**
     * @return mixed
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * @param mixed $password
     * @return $this
     */
    public function setPassword($password)
    {
        $this->password = $password;
        return $this;
    }

    /**
     * @return string
     */
    public function getDn()
    {
        return $this->dn;
    }

    /**
     * @param string $dn
     */
    public function setDn($dn)
    {
        $this->dn = $dn;
    }

}