<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 23.03.2015
 * Time: 11:22
 */

namespace FS\UserBundle\Form\Type;


use Doctrine\ORM\EntityRepository;
use FS\CamBundle\Template\TemplateTypes;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class IORecordType extends AbstractType
{

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder->add('name', null, ['label' => 'Name']);


        $builder->add(
            'markerTemplate',
            'entity',
            [
                'label' => 'Marker',
                'class' => 'FSCamBundle:Template',
                'query_builder' => function (EntityRepository $er) {
                    return $er->createQueryBuilder('t')
                        ->where('t.type = :type and t.hidden = 0')
                        ->setParameter('type', TemplateTypes::TYPE_MARKER);
                },
            ]
        );
        $builder->add(
            'infoTemplate',
            'entity',
            [
                'label' => 'Information',
                'class' => 'FSCamBundle:Template',
                'query_builder' => function (EntityRepository $er) {
                    return $er->createQueryBuilder('t')
                        ->where('t.type = :type and t.hidden = 0')
                        ->setParameter('type', TemplateTypes::TYPE_INFO);
                },
            ]
        );

        $builder->add('ioRecordName', 'text', [
                'label' => 'Recording Name'
            ]
        );
        $builder->add('defaultRetentionRule', 'retention', ['may_inherit' => false]);
    }

    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'FS\UserBundle\Entity\UserGroup',
            )
        );
    }

    /**
     * Returns the name of this type.
     *
     * @return string The name of this type
     */
    public function getName()
    {
        return 'io_group_form';
    }
}