<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 22.08.2015
 * Time: 15:46
 */

namespace FS\UserBundle\Form\Type;


use Doctrine\ORM\EntityManager;
use Doctrine\ORM\EntityRepository;
use FS\UserBundle\Util\ContainerManager;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class ImportUsersType extends AbstractType
{

    private $containerManager;
    private $em;

    /**
     * @param EntityManager $entityManager
     * @param ContainerManager $containerManager
     */
    public function __construct(EntityManager $entityManager, ContainerManager $containerManager)
    {
        $this->containerManager = $containerManager;
        $this->em = $entityManager;
    }
    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('userGroup',
                'entity', [
                    'class' => 'FSUserBundle:UserGroup',
                    'empty_value' => '',
                    'choices' => $this->containerManager->filterArray(
                            $this->em->getRepository('FSUserBundle:UserGroup')->findAll()
                        ),
                    'label' => 'Group to Add',
                    'required' => false,
                    'attr' => array('style' => 'width:100%'),
                ]
            )
            ->add('file', 'file', ['label' => 'Import file']);
    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'FS\UserBundle\Model\ImportUsers'
            )
        );
    }

    /**
     * Returns the name of this type.
     *
     * @return string The name of this type
     */
    public function getName()
    {
        return "fs_import_users";
    }

}