<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 21.03.2016
 * Time: 13:25
 */

namespace FS\UserBundle\Form\Type;


use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class LdapServerType extends AbstractType
{

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('server', 'text', ['label' => 'Server'])
            ->add('username', 'text', ['label' => 'LDAP Bind User'])
            ->add('password', 'repeated', [
                    'type' => 'password',
                    'required' => true,
                    'first_options' => ['label' => 'Password'],
                    'second_options' => ['label' => 'Repeat Password'],
                ]
            );
    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            [
                'data_class' => 'FS\UserBundle\Entity\LdapServer'
            ]
        );
    }

    /**
     * @return string
     */
    public function getName()
    {
        return 'fs_ldap_server';
    }
}