<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 21.03.2016
 * Time: 17:54
 */

namespace FS\UserBundle\Form\Type;


use Doctrine\ORM\EntityManager;
use FS\UserBundle\Util\ContainerManager;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolverInterface;

class LdapUserType extends AbstractType
{

    private $containerManager;
    private $em;

    /**
     * @param EntityManager $entityManager
     * @param ContainerManager $containerManager
     */
    public function __construct(EntityManager $entityManager, ContainerManager $containerManager)
    {
        $this->containerManager = $containerManager;
        $this->em = $entityManager;
    }

    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('bindScript', 'text',
                [
                    'label' => 'LDAP User Account',
                    'required' => true,
                ]
            )
            ->add('userGroup',
                'entity', [
                    'class' => 'FSUserBundle:UserGroup',
                    'empty_value' => '',
                    'choices' => $this->containerManager->filterArray(
                        $this->em->getRepository('FSUserBundle:UserGroup')->findAll()
                    ),
                    'required' => false,
                    'label' => 'Group to Add',
                    'attr' => array('style' => 'width:100%'),

                ]
            )
            ;
    }

    /**
     * @param OptionsResolverInterface $resolver
     */
    public function setDefaultOptions(OptionsResolverInterface $resolver)
    {
        $resolver->setDefaults(
            array(
                'data_class' => 'FS\UserBundle\Model\LdapUser'

            )
        );
    }

    /**
     * @return string
     */
    public function getName()
    {
        return 'fs_ldap_user';
    }
}