<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 07.04.2015
 * Time: 13:31
 */

namespace FS\UserBundle\Repository;


use Doctrine\ORM\EntityRepository;
use FS\UserBundle\Entity\Log;

class LogRepository extends EntityRepository
{
    public function getLogsByType($type)
    {
        $qb = $this->createQueryBuilder('logs');
        $qb->select('logs', 'user');
        $qb->leftJoin('logs.user', 'user');
        if ($type == Log::OB_TYPE_ADMIN) {
            $qb->where('logs.extraInformation = :type');
        } else if ($type == Log::OB_TYPE_USER) {
            $qb->where('logs.extraInformation <> :adminType');
            $qb->orWhere('logs.extraInformation is NULL');
            $qb->andWhere('logs.objectType = :type');
            $qb->setParameter('adminType', Log::OB_TYPE_ADMIN);
        } else if ($type == Log::OB_TYPE_ROOM || $type == Log::OB_TYPE_CAMERA) {

            $qb->where(
                $qb->expr()->andX(
                    $qb->expr()->in('logs.objectType', ':types')
                )
            );
            $qb->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->neq('logs.extraInformation', ':adminType'),
                    $qb->expr()->isNull('logs.extraInformation')
                )
            );
            $qb->setParameter('types', [Log::OB_TYPE_CAMERA, Log::OB_TYPE_ROOM]);
            $qb->setParameter('adminType', Log::OB_TYPE_ADMIN);
            $qb->addOrderBy('logs.actionDate', 'DESC');
            return $qb;

        } else {
            $qb->where('logs.objectType = :type');
        }
        $qb->addOrderBy('logs.actionDate', 'DESC');
        $qb->setParameter('type', $type);

        return $qb;
    }
}