$('#root-container')
    .find('.container-children')
    .addClass('hidden');
$('.child-list').each(function (index, val) {
    if ($(val).find('.container-children').find('li').length == 0) {
        $(val).find('.live-icon').first().remove();
        $(val).find('span').css('padding-left','8px')
    }
});

/* Expand/Collapse functionality code */
var listsState = 'Expand',
    $admin_block = $('.admin-block'),
    messageWarning = $('.admin-block .message-warning');

var setListsState = function () {
    var expanded = $('.fa-minus').length;
    var collapsed = $('.fa-plus').length;
    listsState = expanded >= collapsed ? 'Collapse' : 'Expand';
    $('.list-appearance').html(listsState);
};

var collapseList = function (expandable) {
    var id = expandable.data('container');
    var parent = expandable.parent();
    if (expandable.hasClass('fa-minus')) expandable.removeClass('fa-minus').addClass('fa-plus');
    parent.find('#container-id-'+id).addClass('hidden');
    $(parent).find('.list-expand-object:first').find('.live-icon').each(function() {
        collapseList($(this));
    });
};

var expandList = function (expandable) {
    var id = expandable.data('container');
    var parent = expandable.parent();
    if (expandable.hasClass('fa-plus')) expandable.removeClass('fa-plus').addClass('fa-minus');
    parent.find('#container-id-'+id).removeClass('hidden');
    if ($(parent).parent().attr('id') !== 'root-container') expandList($(parent).parent().prevAll('a'));
};

var switchListsState = function (force) {
    var icons = $('.live-icon');
    var prefState = force || listsState;
    icons.each(function() {
        window[prefState.toLowerCase() + 'List']($(this));
    });
    setListsState();
};

var toggleExpandable = function (expandable) {
    if (expandable.hasClass('fa-plus')) expandList(expandable);
    else collapseList(expandable);
    setListsState();
};

$('.live-icon').click(function() {
    toggleExpandable($(this));
});
$admin_block.on('click', '.list-appearance', function() {
    switchListsState();
});

/* Search field code */
var checkForResults = function (checkable, value) {
    var returnValue = false;
    checkable.children('.list-expandable').each(function() {
        var isChildFounded = checkForResults($(this).children('.list-expand-object'), value);
        if ($(this).children('.list-expand-object-name').html().toLowerCase().indexOf(value) === -1
            && !isChildFounded) {
            $(this).closest('li').addClass('hidden');
        } else {
            $(this).closest('li').removeClass('hidden');
            returnValue = true;
        }
    });
    return returnValue;
};

$admin_block.on('input', '.search-live', function() {
    var value = $(this).val().toLowerCase();

    if (value === '') switchListsState('Collapse');
    else switchListsState('Expand');

    var isResultsFound = checkForResults($('#root-container'), value);

    if (!isResultsFound) messageWarning.html('No result found!');
    else messageWarning.html('');
});