<?php
namespace FS\UserBundle\Twig\Extension;


class GroupLengthExtension extends \Twig_Extension
{
    public function groupLength($group)
    {
        if (!is_array($group)) $group = $group->toArray();
        $newArray = array_filter($group, function($elem) {
            if ($elem->isDeleted()) return false;
            return true;
        });
        return count($newArray);
    }

    public function getFilters()
    {
        return array(
            new \Twig_SimpleFilter('groupLength', array($this, 'groupLength'), array('is_safe' => array('html')))
        );
    }

    /**
     * Returns the name of the extension.
     *
     * @return string The extension name
     */
    public function getName()
    {
        return 'group_length_extension';
    }
}
