<?php
namespace FS\UserBundle\Twig\Extension;


trait TruncateStringTrait
{
    /**
     * Returns the name of the extension.
     *
     * @param string $string String to truncate
     * @param int $len Maximum supported length of string
     * @param int $count Number of separators
     * @param string $symbol Separator
     * @return string Truncated string
     */
    public function truncateString($string, $len, $count = 3, $symbol = '.')
    {
        return strlen($string) > $len
            ? substr($string, 0, $len - $count).str_repeat($symbol, $count)
            : $string;
    }
}
