<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 29.02.2016
 * Time: 11:33
 */

namespace FS\UserBundle\Twig\Extension;


use FS\UserBundle\Entity\User;

class UserDisplayNameExtension extends \Twig_Extension
{
    use TruncateStringTrait;

    public function getFilters()
    {
        return array(
            new \Twig_SimpleFilter('display_name', array($this, 'displayName'), array('is_safe' => array('html')))
        );
    }

    public function displayName(User $user)
    {
        if ($user->getDisplayName() != null) {
            return $this->truncateString($user->getDisplayName(), 11, 2) . "<span title='" . $user->getUsername()
                ."' style='color:#A4A0A0;'> (" . $this->truncateString($user->getUsername(), 9, 2) . ")</span>";
        }
        return $user->getUsername();
    }

    /**
     * Returns the name of the extension.
     *
     * @return string The extension name
     */
    public function getName()
    {
        return "user_display_name_extension";
    }
}