<?php
/**
 * Created by PhpStorm.
 * User: Vladislav
 * Date: 25.12.2015
 * Time: 18:08
 */

namespace FS\UserBundle\Util;


use FS\UserBundle\Entity\Container;
use FS\UserBundle\Entity\User;
use FS\UserBundle\Model\ContainerizedInterface;
use Symfony\Component\Security\Core\SecurityContext;

class ContainerManager
{
    private $securityContext;
    /** @var User $user */
    private $user;
    /** @var  Container $userContainer */
    private $userContainer;

    public function __construct(SecurityContext $securityContext)
    {
        $this->securityContext = $securityContext;
        $this->user = $this->getUser();
        $this->userContaner = null;

        if($this->user != null && $this->user->getUserGroup() != null){
            $this->userContainer = $this->user->getUserGroup()->getContainer();
        }
    }

    /**
     * @param array $entities
     * @return array
     */
    public function filterArray(array $entities)
    {
        $result = [];
        if($this->userContainer == null){
            /** @var ContainerizedInterface $entity */
            foreach($entities as $entity)
            {
                if($entity->getContainer() == null)
                {
                    $result[] = $entity;
                }
            }
            return $result;
        }

        /** @var ContainerizedInterface $entity */
        foreach($entities as $entity)
        {
            if($this->userContainer->isVisible($entity->getContainer()))
            {
                $result[] = $entity;
            }
        }

        return $result;
    }

    /**
     * @return Container|null
     */
    public function getUserContainer()
    {
        return $this->userContainer;
    }

    /**
     * @return array
     */
    public function getContainersList()
    {
        $result = [];
        if($this->userContainer != null){
            $result = $this->userContainer->toArray();
        }

        return $result;
    }

    /**
     * @return mixed|null
     */
    protected function getUser()
    {
        if (null === $token = $this->securityContext->getToken()) {
            return null;
        }

        if (!is_object($user = $token->getUser())) {
            return null;
        }

        return $user;
    }

}