<?php

namespace FS\UserBundle\Util;


use Doctrine\ORM\EntityManager;
use FS\BasicBundle\Model\Loggable;
use FS\UserBundle\Entity\Log;
use FS\UserBundle\Entity\User;

class Logger {

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function logAction($type, Loggable $object, User $user = null, $action, $extraFields = null)
    {
        if ($extraFields === null) $extraFields = function($arg) {};

        $log = new Log();

        $log->setUser($user)
            ->setObjectName($object->getObjectName())
            ->setObjectType($type)
            ->setObjectId($object->getId())
            ->setAction($action);
        $extraFields($log);

        $this->entityManager->persist($log);
        $this->entityManager->flush($log);

        return true;
    }
}